From 19c32d14b88815a658b0ff17b54efd7977aab925 Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Thu, 9 Jun 2022 01:00:07 +0100
Subject: [PATCH 02/21] Remove pyspotify: lookup

---
 mopidy_spotify/library.py    |   4 +-
 mopidy_spotify/lookup.py     | 108 ++++++--------
 mopidy_spotify/playlists.py  |   1 -
 mopidy_spotify/translator.py |  21 ++-
 mopidy_spotify/web.py        |  90 ++++++++----
 tests/conftest.py            |  59 ++++++--
 tests/test_lookup.py         | 152 ++++++--------------
 tests/test_translator.py     |  36 +++++
 tests/test_web.py            | 270 ++++++++++++++++++++++++++---------
 9 files changed, 460 insertions(+), 281 deletions(-)

diff --git a/mopidy_spotify/library.py b/mopidy_spotify/library.py
index b08ff0c3..06ae7757 100644
--- a/mopidy_spotify/library.py
+++ b/mopidy_spotify/library.py
@@ -35,9 +35,7 @@ def get_images(self, uris):
         return images.get_images(self._backend._web_client, uris)
 
     def lookup(self, uri):
-        return lookup.lookup(
-            self._config, self._backend._session, self._backend._web_client, uri
-        )
+        return lookup.lookup(self._config, self._backend._web_client, uri)
 
     def search(self, query=None, uris=None, exact=False):
         return search.search(
diff --git a/mopidy_spotify/lookup.py b/mopidy_spotify/lookup.py
index 085d2e18..a34f05b2 100644
--- a/mopidy_spotify/lookup.py
+++ b/mopidy_spotify/lookup.py
@@ -1,107 +1,81 @@
 import logging
 
-import spotify
 from mopidy_spotify import browse, playlists, translator, utils
-from mopidy_spotify.web import LinkType, WebLink
+from mopidy_spotify.web import LinkType, WebLink, WebError
 
 logger = logging.getLogger(__name__)
 
-_VARIOUS_ARTISTS_URIS = [
-    "spotify:artist:0LyfQWJT6nXafLPZqxe9Of",
-]
 
-
-def lookup(config, session, web_client, uri):
+def lookup(config, web_client, uri):
     if web_client is None or not web_client.logged_in:
         return []
 
     try:
-        web_link = WebLink.from_uri(uri)
+        link = WebLink.from_uri(uri)
     except ValueError as exc:
         logger.info(f"Failed to lookup {uri!r}: {exc}")
         return []
 
     try:
-        if web_link.type == LinkType.PLAYLIST:
-            return _lookup_playlist(config, web_client, uri)
-        elif web_link.type == LinkType.YOUR:
-            return list(_lookup_your(config, session, web_client, uri))
-        elif web_link.type == LinkType.TRACK:
-            return list(_lookup_track(config, web_client, uri))
-        elif web_link.type == LinkType.ALBUM:
-            return list(_lookup_album(config, sp_link))
-        elif web_link.type == LinkType.ARTIST:
+        if link.type == LinkType.PLAYLIST:
+            return _lookup_playlist(config, web_client, link)
+        elif link.type == LinkType.YOUR:
+            return list(_lookup_your(config, web_client, link))
+        elif link.type == LinkType.TRACK:
+            return list(_lookup_track(config, web_client, link))
+        elif link.type == LinkType.ALBUM:
+            return list(_lookup_album(config, web_client, link))
+        elif link.type == LinkType.ARTIST:
             with utils.time_logger("Artist lookup"):
-                return list(_lookup_artist(config, sp_link))
+                return list(_lookup_artist(config, web_client, link))
         else:
             logger.info(
-                f"Failed to lookup {uri!r}: Cannot handle {web_link.type!r}"
+                f"Failed to lookup {uri!r}: Cannot handle {link.type!r}"
             )
             return []
-    except spotify.Error as exc:
-        logger.info(f"Failed to lookup {uri!r}: {exc}")
+    except WebError as exc:
+        logger.info(f"Failed to lookup Spotify {link.type.value} {link.uri!r}: {exc}")
         return []
 
 
-def _lookup_track(config, web_client, uri):
-    web_track = web_client.get_track(uri)
+def _lookup_track(config, web_client, link):
+    web_track = web_client.get_track(link)
 
     if web_track == {}:
-        logger.error(f"Failed to lookup Spotify track URI {uri!r}")
-        return
+        raise WebError("Invalid track response")
 
     track = translator.web_to_track(web_track, bitrate=config["bitrate"])
     if track is not None:
         yield track
 
 
-def _lookup_album(config, sp_link):
-    sp_album = sp_link.as_album()
-    sp_album_browser = sp_album.browse()
-    sp_album_browser.load(config["timeout"])
-    for sp_track in sp_album_browser.tracks:
-        track = translator.to_track(sp_track, bitrate=config["bitrate"])
-        if track is not None:
-            yield track
+def _lookup_album(config, web_client, link):
+    web_album = web_client.get_album(link)
+    if web_album == {}:
+        raise WebError("Invalid album response")
 
+    tracks = translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
+    for track in tracks:
+        yield track
 
-def _lookup_artist(config, sp_link):
-    sp_artist = sp_link.as_artist()
-    sp_artist_browser = sp_artist.browse(
-        type=spotify.ArtistBrowserType.NO_TRACKS
-    )
-    sp_artist_browser.load(config["timeout"])
-
-    # Get all album browsers we need first, so they can start retrieving
-    # data in the background.
-    sp_album_browsers = []
-    for sp_album in sp_artist_browser.albums:
-        sp_album.load(config["timeout"])
-        if not sp_album.is_available:
-            continue
-        if sp_album.type is spotify.AlbumType.COMPILATION:
-            continue
-        if sp_album.artist.link.uri in _VARIOUS_ARTISTS_URIS:
-            continue
-        sp_album_browsers.append(sp_album.browse())
-
-    for sp_album_browser in sp_album_browsers:
-        sp_album_browser.load(config["timeout"])
-        for sp_track in sp_album_browser.tracks:
-            track = translator.to_track(sp_track, bitrate=config["bitrate"])
-            if track is not None:
-                yield track
+
+def _lookup_artist(config, web_client, link):
+    web_albums = web_client.get_artist_albums(link)
+    for web_album in web_albums:
+        tracks = translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
+        for track in tracks:
+            yield track
 
 
-def _lookup_playlist(config, web_client, uri):
-    playlist = playlists.playlist_lookup(web_client, uri, config["bitrate"])
+def _lookup_playlist(config, web_client, link):
+    playlist = playlists.playlist_lookup(web_client, link.uri, config["bitrate"])
     if playlist is None:
-        raise spotify.Error("Playlist Web API lookup failed")
+        raise WebError("Invalid playlist response")
     return playlist.tracks
 
 
-def _lookup_your(config, session, web_client, uri):
-    parts = uri.replace("spotify:your:", "").split(":")
+def _lookup_your(config, web_client, link):
+    parts = link.uri.replace("spotify:your:", "").split(":")
     if len(parts) != 1:
         return
     variant = parts[0]
@@ -123,6 +97,6 @@ def _lookup_your(config, session, web_client, uri):
             album_ref = translator.web_to_album_ref(web_album)
             if album_ref is None:
                 continue
-            sp_link = session.get_link(album_ref.uri)
-            if sp_link.type is spotify.LinkType.ALBUM:
-                yield from _lookup_album(config, sp_link)
+            web_link = WebLink.from_uri(album_ref.uri)
+            if web_link.type == LinkType.ALBUM:
+                yield from _lookup_album(config, web_client, web_link)
diff --git a/mopidy_spotify/playlists.py b/mopidy_spotify/playlists.py
index 09b83c1e..def97c6c 100644
--- a/mopidy_spotify/playlists.py
+++ b/mopidy_spotify/playlists.py
@@ -2,7 +2,6 @@
 
 from mopidy import backend
 
-import spotify
 from mopidy_spotify import translator, utils
 
 
diff --git a/mopidy_spotify/translator.py b/mopidy_spotify/translator.py
index afd8ce8c..c12062c7 100644
--- a/mopidy_spotify/translator.py
+++ b/mopidy_spotify/translator.py
@@ -313,6 +313,22 @@ def web_to_artist(web_artist):
     return models.Artist(uri=ref.uri, name=ref.name)
 
 
+def web_to_album_tracks(web_album, bitrate=None):
+    album = web_to_album(web_album)
+    if album is None:
+        return []
+
+    web_tracks = web_album.get("tracks", {}).get("items", [])
+    if not isinstance(web_tracks, list):
+        return []
+
+    tracks = [
+        web_to_track(web_track, bitrate, album)
+        for web_track in web_tracks
+    ]
+    return [t for t in tracks if t]
+
+
 def web_to_album(web_album):
     ref = web_to_album_ref(web_album)
     if ref is None:
@@ -326,7 +342,7 @@ def web_to_album(web_album):
     return models.Album(uri=ref.uri, name=ref.name, artists=artists)
 
 
-def web_to_track(web_track, bitrate=None):
+def web_to_track(web_track, bitrate=None, album=None):
     ref = web_to_track_ref(web_track)
     if ref is None:
         return
@@ -336,7 +352,8 @@ def web_to_track(web_track, bitrate=None):
     ]
     artists = [a for a in artists if a]
 
-    album = web_to_album(web_track.get("album", {}))
+    if album is None:
+        album = web_to_album(web_track.get("album", {}))
 
     return models.Track(
         uri=ref.uri,
diff --git a/mopidy_spotify/web.py b/mopidy_spotify/web.py
index d67a6382..68b8f77c 100644
--- a/mopidy_spotify/web.py
+++ b/mopidy_spotify/web.py
@@ -440,6 +440,30 @@ def get_user_playlists(self):
         for page in pages:
             yield from page.get("items", [])
 
+    def _with_all_tracks(self, obj, params=None):
+        if params is None:
+            params = {}
+        tracks_path = obj.get("tracks", {}).get("next")
+        track_pages = self.get_all(
+            tracks_path,
+            params=params,
+            ignore_expiry=obj.status_unchanged,
+        )
+
+        more_tracks = []
+        for page in track_pages:
+            if "items" not in page:
+                return {} # Return nothing on error, or what we have so far?
+            more_tracks += page["items"]
+
+        if more_tracks:
+            # Take a copy to avoid changing the cached response.
+            obj = copy.deepcopy(obj)
+            obj.setdefault("tracks", {}).setdefault("items", [])
+            obj["tracks"]["items"] += more_tracks
+        
+        return obj
+
     def get_playlist(self, uri):
         try:
             parsed = WebLink.from_uri(uri)
@@ -455,40 +479,47 @@ def get_playlist(self, uri):
             f"playlists/{parsed.id}",
             params={"fields": self.PLAYLIST_FIELDS, "market": "from_token"},
         )
+        return self._with_all_tracks(playlist, {"fields": self.TRACK_FIELDS})
+        
 
-        tracks_path = playlist.get("tracks", {}).get("next")
-        track_pages = self.get_all(
-            tracks_path,
-            params={"fields": self.TRACK_FIELDS, "market": "from_token"},
-            ignore_expiry=playlist.status_unchanged,
-        )
+    def get_album(self, web_link):
+        if web_link.type != LinkType.ALBUM:
+            logger.error(f"Expecting Spotify album URI")
+            return {}
 
-        more_tracks = []
-        for page in track_pages:
-            if "items" not in page:
-                return {}
-            more_tracks += page.get("items", [])
-        if more_tracks:
-            # Take a copy to avoid changing the cached response.
-            playlist = copy.deepcopy(playlist)
-            playlist.setdefault("tracks", {}).setdefault("items", [])
-            playlist["tracks"]["items"] += more_tracks
+        album = self.get_one(
+            f"albums/{web_link.id}",
+            params={"market": "from_token"},
+        )
+        return self._with_all_tracks(album)
 
-        return playlist
+    def get_artist_albums(self, web_link):
+        if web_link.type != LinkType.ARTIST:
+            logger.error(f"Expecting Spotify artist URI")
+            return []
 
-    def get_track(self, uri):
-        try:
-            parsed = WebLink.from_uri(uri)
-            if parsed.type != LinkType.TRACK:
-                raise ValueError(
-                    f"Could not parse {uri!r} as a Spotify track URI"
-                )
-        except ValueError as exc:
-            logger.error(exc)
+        pages = self.get_all(
+            f"artists/{web_link.id}/albums",
+            params={"market": "from_token", "include_groups": "single,album"},
+        )
+        for page in pages:
+            for album in page["items"]:
+                try:
+                    web_link = WebLink.from_uri(album.get("uri"))
+                except ValueError as exc:
+                    logger.error(exc)
+                    continue
+                full_album = self.get_album(web_link)
+                if full_album.get("is_playable", False):
+                    yield full_album
+
+    def get_track(self, web_link):
+        if web_link.type != LinkType.TRACK:
+            logger.error(f"Expecting Spotify track URI")
             return {}
 
         return self.get_one(
-            f"tracks/{parsed.id}",
+            f"tracks/{web_link.id}",
             params={"market": "from_token"}
         )
 
@@ -547,3 +578,8 @@ def from_uri(cls, uri):
             return cls(uri, LinkType.PLAYLIST, parts[3], parts[1])
 
         raise ValueError(f"Could not parse {uri!r} as a Spotify URI")
+
+
+class WebError(Exception):
+    def __init__(self, message):
+        super().__init__(message)
diff --git a/tests/conftest.py b/tests/conftest.py
index a37fef2b..5ba4def4 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -287,9 +287,9 @@ def sp_playlist_container_mock():
 
 
 @pytest.fixture
-def web_search_mock(web_album_mock, web_artist_mock, web_track_mock):
+def web_search_mock(web_album_mock_base, web_artist_mock, web_track_mock):
     return {
-        "albums": {"items": [web_album_mock]},
+        "albums": {"items": [web_album_mock_base]},
         "artists": {"items": [web_artist_mock]},
         "tracks": {"items": [web_track_mock, web_track_mock]},
     }
@@ -310,30 +310,67 @@ def web_artist_mock():
 
 
 @pytest.fixture
-def web_album_mock(web_artist_mock):
+def web_track_mock_base(web_artist_mock):
+    return {
+        "artists": [web_artist_mock],
+        "disc_number": 1,
+        "duration_ms": 174300,
+        "name": "ABC 123",
+        "track_number": 7,
+        "uri": "spotify:track:abc",
+        "type": "track",
+        "is_playable": True,
+    }
+
+
+@pytest.fixture
+def web_album_mock_base(web_artist_mock):
     return {
         "name": "DEF 456",
         "uri": "spotify:album:def",
         "type": "album",
+        "album_type": "album",
         "artists": [web_artist_mock],
     }
 
 
 @pytest.fixture
-def web_track_mock(web_artist_mock, web_album_mock):
+def web_album_mock(web_album_mock_base, web_track_mock_base):
+    return {
+        **web_album_mock_base,
+        **{"tracks": {"items": [web_track_mock_base] * 10}},
+        "is_playable": True,
+    }
+
+
+@pytest.fixture
+def web_album_mock_base2(web_artist_mock):
     return {
-        "album": web_album_mock,
+        "name": "XYZ 789",
+        "uri": "spotify:album:xyz",
+        "type": "album",
+        "album_type": "album",
         "artists": [web_artist_mock],
-        "disc_number": 1,
-        "duration_ms": 174300,
-        "name": "ABC 123",
-        "track_number": 7,
-        "uri": "spotify:track:abc",
-        "type": "track",
+    }
+
+
+@pytest.fixture
+def web_album_mock2(web_album_mock_base2, web_track_mock_base):
+    return {
+        **web_album_mock_base2,
+        **{"tracks": {"items": [web_track_mock_base] * 2}},
         "is_playable": True,
     }
 
 
+@pytest.fixture
+def web_track_mock(web_track_mock_base, web_album_mock_base):
+    return {
+        **web_track_mock_base,
+        **{"album": web_album_mock_base},
+    }
+
+
 @pytest.fixture
 def web_response_mock(web_track_mock):
     return web.WebResponse(
diff --git a/tests/test_lookup.py b/tests/test_lookup.py
index 2f1cea16..3d1e45a8 100644
--- a/tests/test_lookup.py
+++ b/tests/test_lookup.py
@@ -1,3 +1,4 @@
+import copy
 from unittest import mock
 
 import spotify
@@ -17,106 +18,87 @@ def test_lookup_of_invalid_playlist_uri(provider, caplog):
     assert "Failed to lookup 'spotify:playlist': Could not parse" in caplog.text
 
 
-def test_lookup_of_invalid_track_uri(session_mock, provider, caplog):
-    session_mock.get_link.side_effect = ValueError("an error message")
+def test_lookup_of_invalid_track_uri(web_client_mock, provider, caplog):
+    web_client_mock.get_track.return_value = {}
 
     results = provider.lookup("spotify:track:invalid")
 
     assert len(results) == 0
     assert (
-        "Failed to lookup 'spotify:track:invalid': an error message"
+        "Failed to lookup Spotify track 'spotify:track:invalid': Invalid track response"
         in caplog.text
     )
 
 
-def test_lookup_of_unhandled_uri(session_mock, provider, caplog):
-    sp_link_mock = mock.Mock(spec=spotify.Link)
-    sp_link_mock.type = spotify.LinkType.INVALID
-    session_mock.get_link.return_value = sp_link_mock
-
-    results = provider.lookup("spotify:artist:something")
+def test_lookup_of_unhandled_uri(provider, caplog):
+    results = provider.lookup("spotify:invalid:something")
 
     assert len(results) == 0
     assert (
-        "Failed to lookup 'spotify:artist:something': "
-        "Cannot handle <LinkType.INVALID: 0>" in caplog.text
+        "Failed to lookup 'spotify:invalid:something': "
+        "Could not parse 'spotify:invalid:something' as a Spotify URI" in caplog.text
     )
 
 
-def test_lookup_when_offline(session_mock, sp_track_mock, provider, caplog):
-    session_mock.get_link.return_value = sp_track_mock.link
-    sp_track_mock.link.as_track.return_value.load.side_effect = spotify.Error(
-        "Must be online to load objects"
-    )
+def test_lookup_when_offline(web_client_mock, provider, caplog):
+    web_client_mock.logged_in = False
 
-    results = provider.lookup("spotify:track:abc")
+    results = provider.lookup("spotify:invalid:something")
 
     assert len(results) == 0
-    assert (
-        "Failed to lookup 'spotify:track:abc': Must be online to load objects"
-        in caplog.text
-    )
+    assert "Failed to lookup" not in caplog.text
 
 
-def test_lookup_of_track_uri(session_mock, sp_track_mock, provider):
-    session_mock.get_link.return_value = sp_track_mock.link
+def test_lookup_of_track_uri(web_client_mock, web_track_mock, provider):
+    web_client_mock.get_track.return_value = web_track_mock
 
     results = provider.lookup("spotify:track:abc")
 
-    session_mock.get_link.assert_called_once_with("spotify:track:abc")
-    sp_track_mock.link.as_track.assert_called_once_with()
-    sp_track_mock.load.assert_called_once_with(10)
-
     assert len(results) == 1
     track = results[0]
     assert track.uri == "spotify:track:abc"
     assert track.name == "ABC 123"
     assert track.bitrate == 160
+    assert track.album.name == "DEF 456"
 
 
-def test_lookup_of_album_uri(session_mock, sp_album_browser_mock, provider):
-    sp_album_mock = sp_album_browser_mock.album
-    session_mock.get_link.return_value = sp_album_mock.link
-
+def test_lookup_of_album_uri(web_client_mock, web_album_mock, provider):
+    web_client_mock.get_album.return_value = web_album_mock
+    
     results = provider.lookup("spotify:album:def")
 
-    session_mock.get_link.assert_called_once_with("spotify:album:def")
-    sp_album_mock.link.as_album.assert_called_once_with()
-
-    sp_album_mock.browse.assert_called_once_with()
-    sp_album_browser_mock.load.assert_called_once_with(10)
-
-    assert len(results) == 2
+    assert len(results) == 10
     track = results[0]
     assert track.uri == "spotify:track:abc"
     assert track.name == "ABC 123"
     assert track.bitrate == 160
-
-
-def test_lookup_of_artist_uri(
-    session_mock, sp_artist_browser_mock, sp_album_browser_mock, provider
-):
-    sp_artist_mock = sp_artist_browser_mock.artist
-    sp_album_mock = sp_album_browser_mock.album
-    session_mock.get_link.return_value = sp_artist_mock.link
-
+    assert track.album.name == "DEF 456"
+
+
+def test_lookup_of_artist_uri(web_track_mock, web_album_mock, web_client_mock, provider):
+    web_track_mock2 = copy.deepcopy(web_track_mock)
+    web_track_mock2['name'] = "XYZ track"
+    web_album_mock2 = copy.deepcopy(web_album_mock)
+    web_album_mock2['name'] = "XYZ album"
+    web_album_mock2['tracks']['items'] = [web_track_mock2] * 3
+    
+    web_client_mock.get_artist_albums.return_value = [
+        web_album_mock, web_album_mock2,
+    ]
     results = provider.lookup("spotify:artist:abba")
 
-    session_mock.get_link.assert_called_once_with("spotify:artist:abba")
-    sp_artist_mock.link.as_artist.assert_called_once_with()
-
-    sp_artist_mock.browse.assert_called_once_with(
-        type=spotify.ArtistBrowserType.NO_TRACKS
-    )
-    sp_artist_browser_mock.load.assert_called_once_with(10)
-
-    assert sp_album_mock.browse.call_count == 2
-    assert sp_album_browser_mock.load.call_count == 2
+    assert len(results) == 13
 
-    assert len(results) == 4
     track = results[0]
     assert track.uri == "spotify:track:abc"
     assert track.name == "ABC 123"
+    assert track.album.name == "DEF 456"
+    assert track.bitrate == 160
+
+    track = results[10]
+    assert track.uri == "spotify:track:abc"
+    assert track.name == "XYZ track"
+    assert track.album.name == "XYZ album"
     assert track.bitrate == 160
 
 
@@ -160,15 +142,11 @@ def test_lookup_of_artist_uri_ignores_various_artists_albums(
     assert len(results) == 0
 
 
-def test_lookup_of_playlist_uri(
-    session_mock, web_client_mock, web_playlist_mock, sp_track_mock, provider
-):
+def test_lookup_of_playlist_uri(web_client_mock, web_playlist_mock, provider):
     web_client_mock.get_playlist.return_value = web_playlist_mock
-    session_mock.get_link.return_value = sp_track_mock.link
 
     results = provider.lookup("spotify:playlist:alice:foo")
 
-    session_mock.get_link.assert_called_once_with("spotify:track:abc")
     web_client_mock.get_playlist.assert_called_once_with(
         "spotify:playlist:alice:foo"
     )
@@ -180,20 +158,6 @@ def test_lookup_of_playlist_uri(
     assert track.bitrate == 160
 
 
-def test_lookup_of_playlist_uri_when_not_logged_in(
-    web_client_mock, provider, caplog
-):
-    web_client_mock.user_id = None
-
-    results = provider.lookup("spotify:playlist:alice:foo")
-
-    assert len(results) == 0
-    assert (
-        "Failed to lookup 'spotify:playlist:alice:foo': "
-        "Playlist Web API lookup failed" in caplog.text
-    )
-
-
 def test_lookup_of_yourtracks_uri(web_client_mock, web_track_mock, provider):
     web_saved_track_mock = {"track": web_track_mock}
     web_client_mock.get_all.return_value = [
@@ -208,50 +172,26 @@ def test_lookup_of_yourtracks_uri(web_client_mock, web_track_mock, provider):
         assert track.uri == "spotify:track:abc"
         assert track.name == "ABC 123"
         assert track.bitrate == 160
+        assert track.album.name == "DEF 456"
 
 
-def test_lookup_of_youralbums_uri(
-    session_mock,
-    web_client_mock,
-    web_album_mock,
-    sp_album_browser_mock,
-    provider,
-):
+def test_lookup_of_youralbums_uri(web_client_mock, web_album_mock, provider):
     web_saved_album_mock = {"album": web_album_mock}
     web_client_mock.get_all.return_value = [
         {"items": [web_saved_album_mock, web_saved_album_mock]},
         {"items": [web_saved_album_mock, web_saved_album_mock]},
     ]
-
-    sp_album_mock = sp_album_browser_mock.album
-    session_mock.get_link.return_value = sp_album_mock.link
+    web_client_mock.get_album.return_value = web_album_mock
 
     results = provider.lookup("spotify:your:albums")
 
-    get_link_call = mock.call("spotify:album:def")
-    assert session_mock.get_link.call_args_list == [
-        get_link_call,
-        get_link_call,
-        get_link_call,
-        get_link_call,
-    ]
-    assert sp_album_mock.link.as_album.call_count == 4
-
-    assert sp_album_mock.browse.call_count == 4
-    load_call = mock.call(10)
-    assert sp_album_browser_mock.load.call_args_list == [
-        load_call,
-        load_call,
-        load_call,
-        load_call,
-    ]
-
-    assert len(results) == 8
+    assert len(results) == 4*10
     for track in results:
         assert track.uri == "spotify:track:abc"
         assert track.name == "ABC 123"
         assert track.album.uri == "spotify:album:def"
         assert track.bitrate == 160
+        assert track.album.name == "DEF 456"
 
 
 def test_lookup_of_your_uri_when_not_logged_in(web_client_mock, provider):
diff --git a/tests/test_translator.py b/tests/test_translator.py
index f40cb8bf..a0120315 100644
--- a/tests/test_translator.py
+++ b/tests/test_translator.py
@@ -788,6 +788,34 @@ def test_ignores_invalid_artists(self, web_album_mock, web_artist_mock):
         assert album.name == "DEF 456"
         assert list(album.artists) == artists
 
+    def test_returns_empty_artists_list_if_artist_is_empty(self, web_album_mock):
+        web_album_mock["artists"] = []
+
+        album = translator.web_to_album(web_album_mock)
+
+        assert list(album.artists) == []
+
+    def test_caches_results(self, web_album_mock):
+        album1 = translator.web_to_album(web_album_mock)
+        album2 = translator.web_to_album(web_album_mock)
+
+        assert album1 is album2
+
+    def test_web_to_album_tracks(self, web_album_mock):
+        tracks = translator.web_to_album_tracks(web_album_mock)
+
+        assert len(tracks) == 10
+        track = tracks[0]
+        assert track.album.name == "DEF 456"
+        assert track.album.artists == track.artists
+
+    def test_web_to_album_tracks_empty(self, web_album_mock):
+        web_album_mock["tracks"]["items"] = []
+
+        tracks = translator.web_to_album_tracks(web_album_mock)
+
+        assert len(tracks) == 0
+
 
 class TestWebToTrack:
     def test_calls_web_to_track_ref(self, web_track_mock):
@@ -828,6 +856,14 @@ def test_sets_bitrate(self, web_track_mock):
 
         assert track.bitrate == 100
 
+    def test_sets_specified_album(self, web_track_mock):
+        alt_album = models.Album(uri="spotify:album:xyz", name="XYZ 789")
+
+        track = translator.web_to_track(web_track_mock, album=alt_album)
+
+        assert track.album.uri == "spotify:album:xyz"
+        assert track.album.name == "XYZ 789"
+
     def test_filters_out_none_artists(self, web_track_mock):
         web_track_mock["artists"].insert(0, {})
         web_track_mock["artists"].insert(0, {"foo": "bar"})
